import { Link } from "@tanstack/react-router";

import { toast } from "sonner";
import {
	Card,
	CardContent,
	CardDescription,
	CardHeader,
	CardTitle,
} from "@/components/ui/card";
import { authClient } from "@/lib/auth-client";
import { useAppForm } from "@/lib/formSutff";

export default function ResetPassword({ token }: { token: string }) {
	const form = useAppForm({
		defaultValues: {
			password: "",
			confirmPassword: "",
		},
		onSubmit: async ({ value }) => {
			if (!token) {
				toast.error("No token was included");
				return;
			}

			const { data, error } = await authClient.resetPassword({
				newPassword: value.password,
				token,
			});

			if (data) {
				toast.success("Password has been reset");
			}

			if (error) {
				toast.error(error.message);
			}
		},
	});

	return (
		<div className="flex justify-center mt-2">
			<Card className="p-6 w-96">
				<CardHeader>
					<CardTitle>Reset your password</CardTitle>
					<CardDescription>
						Enter your email address and we’ll send you a reset link
					</CardDescription>
				</CardHeader>
				<CardContent>
					<form
						onSubmit={(e) => {
							e.preventDefault();
							form.handleSubmit();
						}}
					>
						<form.AppField name="password">
							{(field) => (
								<field.InputPasswordField
									label="New Password"
									required={true}
								/>
							)}
						</form.AppField>
						<form.AppField name="confirmPassword">
							{(field) => (
								<field.InputPasswordField
									label="Confirm Password"
									required={true}
								/>
							)}
						</form.AppField>

						<div className="flex justify-end mt-6">
							<form.AppForm>
								<form.SubmitButton>Send Reset Link</form.SubmitButton>
							</form.AppForm>
						</div>
					</form>

					<div className="mt-6 text-center text-sm text-gray-600">
						Remembered your password?{" "}
						<Link
							to="/login"
							className="text-primary underline underline-offset-4 hover:text-primary/80"
						>
							Back to login
						</Link>
					</div>
				</CardContent>
			</Card>
		</div>
	);
}
